#!/usr/local/bin/perl
#
# 97/02/18 15:53:34

$tblbegin =<<EndOfText;
<table border=1 cellspacing=1 cellpadding=5>
<tbody>
<tr align=left>
<th>Variable</th><th>Value</th>
</tr>
EndOfText

$tblend =<<EndOfText;
</tbody>
</table>
EndOfText

$rcfile = shift @ARGV;
$varfile = shift @ARGV;

open(RCFILE, $rcfile) or die "Unable to open $rcfile\n";
while (<RCFILE>) {
    chomp;
    $type = '';
    ($rc, $type) = split(/:/, $_, 2);
    $Rc2Type{$rc} = $type;
}
close(RCFILE);

open(VARFILE, $varfile) or die "Unable to open $varfile\n";
while (<VARFILE>) {
    chomp;
    ($var, $type, $txt) = split(/:/, $_, 3);
    $IdxVars{$var} = $txt  	if $type =~ /I/;
    $TIdxVars{$var} = $txt  	if $type =~ /T/;
    $IdxVarsNM{$var} = $txt  	if $type =~ /i/;
    $TIdxVarsNM{$var} = $txt  	if $type =~ /t/;
    $MsgVars{$var} = $txt  	if $type =~ /M/;
    $MsgFixVars{$var} = $txt  	if $type =~ /F/;
}
close(VARFILE);

$tmpfile = ",$$";
foreach $file (@ARGV) {
    ($rc = $file) =~ s/\..*//;
    next  unless $Rc2Type{$rc};

    $hash = \%IdxVars   	if $Rc2Type{$rc} =~ /I/;
    $hash = \%TIdxVars  	if $Rc2Type{$rc} =~ /T/;
    $hash = \%IdxVarsNM   	if $Rc2Type{$rc} =~ /i/;
    $hash = \%TIdxVarsNM  	if $Rc2Type{$rc} =~ /t/;
    $hash = \%MsgVars   	if $Rc2Type{$rc} =~ /M/;
    $hash = \%MsgFixVars  	if $Rc2Type{$rc} =~ /F/;

    &cp($file, $tmpfile);
    open(IN, $tmpfile) or die "Unable to open $tmpfile\n";
    open(OUT, "> $file") or die "Unable to create $file\n";
    while (<IN>) {
	next  unless /<h2>Resource Variables/i;
	print OUT $_;
	while (<IN>) {
	     next unless /^<!-- \*\*\*/;
	     $divider = $_;
	     last;
	}
	print OUT "\n";
	print OUT $tblbegin;
	foreach $var (sort keys %$hash) {
	    print OUT "<tr valign=top>\n",
		      '<td><a name="', $var, '"><strong><code>$',
		      uc $var, '$</code></strong></a></td>',
		      "\n<td>", $hash->{$var}, "</td>\n</tr>\n";
	}
	print OUT $tblend;
	print OUT "\n", $divider;
	$_ = '';
    } continue {
	print OUT $_;
    }
}

unlink $tmpfile;

exit 0;

sub cp {
    my($src, $dst) = @_;
    open(SRC, $src) || die "Unable to open $src: $!\n";
    open(DST, "> $dst") || die "Unable to create $dst: $!\n";
    if (-B $src) { binmode( SRC ); binmode( DST ); }
    print DST <SRC>;
    close(SRC);
    close(DST);
}

